//------------------------------------------------------------------
#property copyright ""
#property link      ""
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 DodgerBlue
#property indicator_color3 Fuchsia
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_width3 2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    DzLookBackBars         = 35;
extern double DzStartBuyProbability  = 0.10;
extern double DzStartSellProbability = 0.10;

double RF.RangeLevel;
double RF_LinearValue[];
double RF_LowerLimit[];
double RF_UpperLimit[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, RF_UpperLimit);  SetIndexLabel(0, "RF Upper Limit");
   SetIndexBuffer(1, RF_LowerLimit);  SetIndexLabel(1, "RF Lower Limit");
   SetIndexBuffer(2, RF_LinearValue); SetIndexLabel(2, "RF Linear Value");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int i,r,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-34);

      for(i = limit; i >= 0; i--)
      {
         double RF.MA1 = 100.0 * (iMA(NULL, 0, 3, 0, MODE_LWMA, PRICE_CLOSE, i) - iMA(NULL, 0, 34, 0, MODE_LWMA, PRICE_CLOSE, i)) * iATR(NULL, 0, 3, i) + 0.00001;
         double RF.MA2 = RF.MA1 / iMA(NULL, 0, 34, 0, MODE_LWMA, PRICE_CLOSE, i) / iATR(NULL, 0, 34, i);
         double RF.Exp = (MathExp(2.0 * RF.MA2) - 1.0) / (MathExp(2.0 * RF.MA2) + 1.0);
         RF_LinearValue[i] = RF.Exp;
         RF_LowerLimit[i]  = dzSellP(RF_LinearValue, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
         RF_UpperLimit[i]  = dzBuyP (RF_LinearValue, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
   }
   return(0);
}